Index: /code/branches/core/src/network/Synchronisable.h
===================================================================
--- /code/branches/core/src/network/Synchronisable.h	(revision 851)
+++ /code/branches/core/src/network/Synchronisable.h	(revision 852)
@@ -16,5 +16,4 @@
 
 #include "NetworkPrereqs.h"
-#include "core/CoreIncludes.h"
 
 namespace network
Index: /code/branches/core/src/orxonox/CMakeLists.txt
===================================================================
--- /code/branches/core/src/orxonox/CMakeLists.txt	(revision 851)
+++ /code/branches/core/src/orxonox/CMakeLists.txt	(revision 852)
@@ -3,4 +3,5 @@
   Main.cc
   Orxonox.cc
+  objects/Tickable.cc
 #  SpaceshipSteering.cc
 #  hud/HUD.cc
@@ -9,4 +10,5 @@
 #  tools/Light.cc
   tools/Mesh.cc
+  tools/Timer.cc
 #  objects/Ambient.cc
 #  objects/Camera.cc
Index: /code/branches/core/src/orxonox/Orxonox.cc
===================================================================
--- /code/branches/core/src/orxonox/Orxonox.cc	(revision 851)
+++ /code/branches/core/src/orxonox/Orxonox.cc	(revision 852)
@@ -54,4 +54,5 @@
 //***** ORXONOX ****
 //misc
+#include "core/CoreIncludes.h"
 #include "util/Sleep.h"
 
Index: /code/branches/core/src/orxonox/OrxonoxStableHeaders.h
===================================================================
--- /code/branches/core/src/orxonox/OrxonoxStableHeaders.h	(revision 851)
+++ /code/branches/core/src/orxonox/OrxonoxStableHeaders.h	(revision 852)
@@ -73,5 +73,5 @@
 //#include "audio/AudioManager.h"
 
-#include "core/CoreIncludes.h"
+//#include "core/CoreIncludes.h"
 #include "core/BaseObject.h"
 //#include "core/ArgReader.h"
Index: /code/branches/core/src/orxonox/core/BaseObject.cc
===================================================================
--- /code/branches/core/src/orxonox/core/BaseObject.cc	(revision 851)
+++ /code/branches/core/src/orxonox/core/BaseObject.cc	(revision 852)
@@ -33,4 +33,5 @@
 #include "util/tinyxml/tinyxml.h"
 
+#include "core/CoreIncludes.h"
 #include "BaseObject.h"
 #include "XMLPort.h"
Index: /code/branches/core/src/orxonox/core/BaseObject.h
===================================================================
--- /code/branches/core/src/orxonox/core/BaseObject.h	(revision 851)
+++ /code/branches/core/src/orxonox/core/BaseObject.h	(revision 852)
@@ -39,5 +39,5 @@
 #include "util/XMLIncludes.h"
 
-#include "CoreIncludes.h"
+#include "OrxonoxClass.h"
 
 namespace orxonox
Index: /code/branches/core/src/orxonox/core/DebugLevel.cc
===================================================================
--- /code/branches/core/src/orxonox/core/DebugLevel.cc	(revision 851)
+++ /code/branches/core/src/orxonox/core/DebugLevel.cc	(revision 852)
@@ -32,4 +32,5 @@
 
 #include "DebugLevel.h"
+#include "CoreIncludes.h"
 
 namespace orxonox
Index: /code/branches/core/src/orxonox/core/DebugLevel.h
===================================================================
--- /code/branches/core/src/orxonox/core/DebugLevel.h	(revision 851)
+++ /code/branches/core/src/orxonox/core/DebugLevel.h	(revision 852)
@@ -41,5 +41,4 @@
 #include "OrxonoxClass.h"
 #include "OutputHandler.h"
-#include "CoreIncludes.h"
 
 namespace orxonox
Index: /code/branches/core/src/orxonox/core/Loader.cc
===================================================================
--- /code/branches/core/src/orxonox/core/Loader.cc	(revision 851)
+++ /code/branches/core/src/orxonox/core/Loader.cc	(revision 852)
@@ -32,6 +32,6 @@
 #include "Iterator.h"
 #include "Debug.h"
+#include "CoreIncludes.h"
 
-//#define TIXML_USE_TICPP
 #include "util/tinyxml/ticpp.h"
 
Index: /code/branches/core/src/orxonox/objects/Test.h
===================================================================
--- /code/branches/core/src/orxonox/objects/Test.h	(revision 851)
+++ /code/branches/core/src/orxonox/objects/Test.h	(revision 852)
@@ -30,5 +30,4 @@
 
 #include "core/BaseObject.h"
-#include "../core/CoreIncludes.h"
 
 namespace orxonox
Index: /code/branches/core/src/orxonox/objects/Tickable.cc
===================================================================
--- /code/branches/core/src/orxonox/objects/Tickable.cc	(revision 852)
+++ /code/branches/core/src/orxonox/objects/Tickable.cc	(revision 852)
@@ -0,0 +1,13 @@
+#include "core/CoreIncludes.h"
+#include "Tickable.h"
+
+namespace orxonox
+{
+    /**
+        @brief Constructor: Registers the object in the Tickable-list
+    */
+    Tickable::Tickable()
+    {
+        RegisterRootObject(Tickable);
+    }
+}
Index: /code/branches/core/src/orxonox/objects/Tickable.h
===================================================================
--- /code/branches/core/src/orxonox/objects/Tickable.h	(revision 851)
+++ /code/branches/core/src/orxonox/objects/Tickable.h	(revision 852)
@@ -45,6 +45,4 @@
 #include "../OrxonoxPrereqs.h"
 
-#include "../core/CoreIncludes.h"
-
 namespace orxonox
 {
@@ -62,8 +60,5 @@
 
         protected:
-            /**
-                @brief Constructor: Registers the object in the Tickable-list
-            */
-            Tickable() { RegisterRootObject(Tickable); }
+            Tickable();
     };
 
Index: /code/branches/core/src/orxonox/objects/WorldEntity.h
===================================================================
--- /code/branches/core/src/orxonox/objects/WorldEntity.h	(revision 851)
+++ /code/branches/core/src/orxonox/objects/WorldEntity.h	(revision 852)
@@ -11,5 +11,4 @@
 #include "network/Synchronisable.h"
 //#include "util/tinyxml/tinyxml.h"
-#include "../core/CoreIncludes.h"
 #include "core/BaseObject.h"
 #include "Tickable.h"
Index: /code/branches/core/src/orxonox/objects/test1.cc
===================================================================
--- /code/branches/core/src/orxonox/objects/test1.cc	(revision 851)
+++ /code/branches/core/src/orxonox/objects/test1.cc	(revision 852)
@@ -29,7 +29,5 @@
 #include "test2.h"
 #include "test3.h"
-#include "util/tinyxml/tinyxml.h"
-#include "../Orxonox.h"
-#include <OgreSceneManager.h>
+#include "core/CoreIncludes.h"
 
 namespace orxonox
Index: /code/branches/core/src/orxonox/objects/test2.cc
===================================================================
--- /code/branches/core/src/orxonox/objects/test2.cc	(revision 851)
+++ /code/branches/core/src/orxonox/objects/test2.cc	(revision 852)
@@ -29,4 +29,5 @@
 #include "test2.h"
 #include "test3.h"
+#include "core/CoreIncludes.h"
 
 namespace orxonox
Index: /code/branches/core/src/orxonox/objects/test3.cc
===================================================================
--- /code/branches/core/src/orxonox/objects/test3.cc	(revision 851)
+++ /code/branches/core/src/orxonox/objects/test3.cc	(revision 852)
@@ -29,4 +29,5 @@
 #include "test2.h"
 #include "test3.h"
+#include "core/CoreIncludes.h"
 
 namespace orxonox
Index: /code/branches/core/src/orxonox/objects/test3.h
===================================================================
--- /code/branches/core/src/orxonox/objects/test3.h	(revision 851)
+++ /code/branches/core/src/orxonox/objects/test3.h	(revision 852)
@@ -3,4 +3,5 @@
 
 #include "core/BaseObject.h"
+#include "util/Math.h"
 
 namespace orxonox
Index: /code/branches/core/src/orxonox/objects/weapon/AmmunitionDump.h
===================================================================
--- /code/branches/core/src/orxonox/objects/weapon/AmmunitionDump.h	(revision 851)
+++ /code/branches/core/src/orxonox/objects/weapon/AmmunitionDump.h	(revision 852)
@@ -37,5 +37,4 @@
 
 #include "network/Synchronisable.h"
-//#include "../core/CoreIncludes.h"
 #include "core/BaseObject.h"
 
Index: /code/branches/core/src/orxonox/objects/weapon/BulletManager.h
===================================================================
--- /code/branches/core/src/orxonox/objects/weapon/BulletManager.h	(revision 851)
+++ /code/branches/core/src/orxonox/objects/weapon/BulletManager.h	(revision 852)
@@ -38,5 +38,4 @@
 #include "network/Synchronisable.h"
 #include "util/tinyxml/tinyxml.h"
-#include "../../core/CoreIncludes.h"
 #include "core/BaseObject.h"
 #include "../Tickable.h"
Index: /code/branches/core/src/orxonox/tools/BillboardSet.h
===================================================================
--- /code/branches/core/src/orxonox/tools/BillboardSet.h	(revision 851)
+++ /code/branches/core/src/orxonox/tools/BillboardSet.h	(revision 852)
@@ -7,6 +7,4 @@
 
 #include "../OrxonoxPrereqs.h"
-
-#include "../core/CoreIncludes.h"
 #include "util/Math.h"
 
Index: /code/branches/core/src/orxonox/tools/Timer.cc
===================================================================
--- /code/branches/core/src/orxonox/tools/Timer.cc	(revision 852)
+++ /code/branches/core/src/orxonox/tools/Timer.cc	(revision 852)
@@ -0,0 +1,19 @@
+#include "core/CoreIncludes.h"
+#include "Timer.h"
+
+namespace orxonox
+{
+    /**
+        @brief Constructor: Sets the default-values.
+    */
+    TimerBase::TimerBase()
+    {
+        RegisterRootObject(TimerBase);
+
+        this->interval_ = 0;
+        this->bLoop_ = false;
+        this->bActive_ = false;
+
+        this->time_ = 0;
+    }
+}
Index: /code/branches/core/src/orxonox/tools/Timer.h
===================================================================
--- /code/branches/core/src/orxonox/tools/Timer.h	(revision 851)
+++ /code/branches/core/src/orxonox/tools/Timer.h	(revision 852)
@@ -59,8 +59,5 @@
 
 #include <OgreFrameListener.h>
-
 #include "../OrxonoxPrereqs.h"
-
-#include "../core/CoreIncludes.h"
 
 namespace orxonox
@@ -72,15 +69,5 @@
 
         public:
-            /** @brief Constructor: Sets the default-values. */
-            TimerBase()
-            {
-                RegisterRootObject(TimerBase);
-
-                this->interval_ = 0;
-                this->bLoop_ = false;
-                this->bActive_ = false;
-
-                this->time_ = 0;
-            }
+            TimerBase();
 
             virtual void run() const = 0;