Index: code/branches/core/src/orxonox/core/BaseObject.cc
===================================================================
--- code/branches/core/src/orxonox/core/BaseObject.cc	(revision 869)
+++ code/branches/core/src/orxonox/core/BaseObject.cc	(revision 870)
@@ -78,9 +78,7 @@
         @return The XML-element
     */
-    Element& BaseObject::XMLPort(Element& xmlelement, bool loading)
+    void BaseObject::XMLPort(Element& xmlelement, bool loading)
     {
         XMLPortParam(BaseObject, "name", setName, getName, xmlelement, loading);
-
-        return xmlelement;
     }
 
Index: code/branches/core/src/orxonox/core/BaseObject.h
===================================================================
--- code/branches/core/src/orxonox/core/BaseObject.h	(revision 869)
+++ code/branches/core/src/orxonox/core/BaseObject.h	(revision 870)
@@ -50,5 +50,5 @@
             virtual ~BaseObject();
             virtual void loadParams(TiXmlElement* xmlElem);
-            virtual Element& XMLPort(Element& xmlelement, bool loading);
+            virtual void XMLPort(Element& xmlelement, bool loading);
 
             /** @brief Sets the name of the object. @param name The name */
Index: code/branches/core/src/orxonox/objects/Ambient.cc
===================================================================
--- code/branches/core/src/orxonox/objects/Ambient.cc	(revision 869)
+++ code/branches/core/src/orxonox/objects/Ambient.cc	(revision 870)
@@ -85,11 +85,9 @@
         @return The XML-element
     */
-    Element& Ambient::XMLPort(Element& xmlelement, bool loading)
+    void Ambient::XMLPort(Element& xmlelement, bool loading)
     {
         BaseObject::XMLPort(xmlelement, loading);
 
         XMLPortParamLoadOnly(Ambient, "colourvalue", setAmbientLight, xmlelement, loading);
-
-        return xmlelement;
     }
 }
Index: code/branches/core/src/orxonox/objects/Ambient.h
===================================================================
--- code/branches/core/src/orxonox/objects/Ambient.h	(revision 869)
+++ code/branches/core/src/orxonox/objects/Ambient.h	(revision 870)
@@ -15,5 +15,5 @@
 
             void loadParams(TiXmlElement* xmlElem);
-            virtual Element& XMLPort(Element& xmlelement, bool loading);
+            virtual void XMLPort(Element& xmlelement, bool loading);
             void setAmbientLight(const ColourValue& colour);
 
Index: code/branches/core/src/orxonox/objects/Model.cc
===================================================================
--- code/branches/core/src/orxonox/objects/Model.cc	(revision 869)
+++ code/branches/core/src/orxonox/objects/Model.cc	(revision 870)
@@ -67,5 +67,5 @@
         @return The XML-element
     */
-    Element& Model::XMLPort(Element& xmlelement, bool loading)
+    void Model::XMLPort(Element& xmlelement, bool loading)
     {
         WorldEntity::XMLPort(xmlelement, loading);
@@ -74,6 +74,4 @@
 
         create();
-
-        return xmlelement;
     }
 
Index: code/branches/core/src/orxonox/objects/Model.h
===================================================================
--- code/branches/core/src/orxonox/objects/Model.h	(revision 869)
+++ code/branches/core/src/orxonox/objects/Model.h	(revision 870)
@@ -18,5 +18,5 @@
             virtual ~Model();
             virtual void loadParams(TiXmlElement* xmlElem);
-            virtual Element& XMLPort(Element& xmlelement, bool loading);
+            virtual void XMLPort(Element& xmlelement, bool loading);
             void setMesh(const std::string& meshname);
             bool create();
Index: code/branches/core/src/orxonox/objects/Skybox.cc
===================================================================
--- code/branches/core/src/orxonox/objects/Skybox.cc	(revision 869)
+++ code/branches/core/src/orxonox/objects/Skybox.cc	(revision 870)
@@ -77,11 +77,9 @@
         @return The XML-element
     */
-    Element& Skybox::XMLPort(Element& xmlelement, bool loading)
+    void Skybox::XMLPort(Element& xmlelement, bool loading)
     {
         BaseObject::XMLPort(xmlelement, loading);
 
         XMLPortParamLoadOnly(Skybox, "src", setSkybox, xmlelement, loading);
-
-        return xmlelement;
     }
 }
Index: code/branches/core/src/orxonox/objects/Skybox.h
===================================================================
--- code/branches/core/src/orxonox/objects/Skybox.h	(revision 869)
+++ code/branches/core/src/orxonox/objects/Skybox.h	(revision 870)
@@ -17,5 +17,5 @@
 
             void loadParams(TiXmlElement* xmlElem);
-            virtual Element& XMLPort(Element& xmlelement, bool loading);
+            virtual void XMLPort(Element& xmlelement, bool loading);
             void setSkybox(const std::string& skyboxname);
 
Index: code/branches/core/src/orxonox/objects/SpaceShip.cc
===================================================================
--- code/branches/core/src/orxonox/objects/SpaceShip.cc	(revision 869)
+++ code/branches/core/src/orxonox/objects/SpaceShip.cc	(revision 870)
@@ -291,5 +291,5 @@
         @return The XML-element
     */
-    Element& SpaceShip::XMLPort(Element& xmlelement, bool loading)
+    void SpaceShip::XMLPort(Element& xmlelement, bool loading)
     {
         Model::XMLPort(xmlelement, loading);
@@ -303,6 +303,4 @@
         XMLPortParamLoadOnly(SpaceShip, "transDamp", setTransDamp, xmlelement, loading);
         XMLPortParamLoadOnly(SpaceShip, "rotDamp", setRotDamp, xmlelement, loading);
-
-        return xmlelement;
     }
 
Index: code/branches/core/src/orxonox/objects/SpaceShip.h
===================================================================
--- code/branches/core/src/orxonox/objects/SpaceShip.h	(revision 869)
+++ code/branches/core/src/orxonox/objects/SpaceShip.h	(revision 870)
@@ -24,5 +24,5 @@
             void setConfigValues();
             virtual void loadParams(TiXmlElement* xmlElem);
-            virtual Element& XMLPort(Element& xmlelement, bool loading);
+            virtual void XMLPort(Element& xmlelement, bool loading);
             virtual void tick(float dt);
 
Index: code/branches/core/src/orxonox/objects/WorldEntity.cc
===================================================================
--- code/branches/core/src/orxonox/objects/WorldEntity.cc	(revision 869)
+++ code/branches/core/src/orxonox/objects/WorldEntity.cc	(revision 870)
@@ -171,5 +171,5 @@
         @return The XML-element
     */
-    Element& WorldEntity::XMLPort(Element& xmlelement, bool loading)
+    void WorldEntity::XMLPort(Element& xmlelement, bool loading)
     {
         BaseObject::XMLPort(xmlelement, loading);
@@ -183,6 +183,4 @@
 
         XMLPortObject(WorldEntity, WorldEntity, "attached", attachWorldEntity, getAttachedWorldEntity, xmlelement, loading);
-
-        return xmlelement;
     }
 
Index: code/branches/core/src/orxonox/objects/WorldEntity.h
===================================================================
--- code/branches/core/src/orxonox/objects/WorldEntity.h	(revision 869)
+++ code/branches/core/src/orxonox/objects/WorldEntity.h	(revision 870)
@@ -25,5 +25,5 @@
             virtual void tick(float dt);
             virtual void loadParams(TiXmlElement* xmlElem);
-            virtual Element& XMLPort(Element& xmlelement, bool loading);
+            virtual void XMLPort(Element& xmlelement, bool loading);
             bool create();
 